// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.seller;

import fr.ifremer.adagio.core.dao.referential.location.Location;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * Vendeur, en charge de la vente d'un ensemble de produits d'un navire.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class Seller
    implements Serializable, Comparable<Seller>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -6888058020105206775L;

    // Generate 4 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private String registrationCode;

    /**
     * Code administratif du vendeur
     * @return this.registrationCode String
     */
    public String getRegistrationCode()
    {
        return this.registrationCode;
    }

    /**
     * Code administratif du vendeur
     * @param registrationCodeIn String
     */
    public void setRegistrationCode(String registrationCodeIn)
    {
        this.registrationCode = registrationCodeIn;
    }

    private String name;

    /**
     * 
     * @return this.name String
     */
    public String getName()
    {
        return this.name;
    }

    /**
     * 
     * @param nameIn String
     */
    public void setName(String nameIn)
    {
        this.name = nameIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 5 associations
    private SellerType sellerType;

    /**
     * Type de vendeur
     * @return this.sellerType SellerType
     */
    public SellerType getSellerType()
    {
        return this.sellerType;
    }

    /**
     * Type de vendeur
     * @param sellerTypeIn SellerType
     */
    public void setSellerType(SellerType sellerTypeIn)
    {
        this.sellerType = sellerTypeIn;
    }

    private Location baseSaleLocation;

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @return this.baseSaleLocation Location
     */
    public Location getBaseSaleLocation()
    {
        return this.baseSaleLocation;
    }

    /**
     * Représente un lieu au sens général du terme. Il peut s'agir d'un lieu ponctuel, linéaire ou
     * surfacique.
     * Suivant sa classification et son niveau, il peut s'agir d'un secteur FAO, un port de pêche,
     * un
     * quartier maritime, une criée, etc.
     * Nombre de lignes : lieux terrestre : 4500 + secteurs : 11210 + strates : 1000 + localités :
     * 200
     * @param baseSaleLocationIn Location
     */
    public void setBaseSaleLocation(Location baseSaleLocationIn)
    {
        this.baseSaleLocation = baseSaleLocationIn;
    }

    /**
     * Returns <code>true</code> if the argument is an Seller instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof Seller))
        {
            return false;
        }
        final Seller that = (Seller)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link Seller}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link Seller}.
         * @return new SellerImpl()
         */
        public static Seller newInstance()
        {
            return new SellerImpl();
        }

        /**
         * Constructs a new instance of {@link Seller}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param sellerType SellerType
         * @return newInstance
         */
        public static Seller newInstance(SellerType sellerType)
        {
            final Seller entity = new SellerImpl();
            entity.setSellerType(sellerType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link Seller}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param registrationCode String
         * @param name String
         * @param updateDate Timestamp
         * @param sellerType SellerType
         * @param baseSaleLocation Location
         * @return newInstance Seller
         */
        public static Seller newInstance(String registrationCode, String name, Timestamp updateDate, SellerType sellerType, Location baseSaleLocation)
        {
            final Seller entity = new SellerImpl();
            entity.setRegistrationCode(registrationCode);
            entity.setName(name);
            entity.setUpdateDate(updateDate);
            entity.setSellerType(sellerType);
            entity.setBaseSaleLocation(baseSaleLocation);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(Seller o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getRegistrationCode() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getRegistrationCode().compareTo(o.getRegistrationCode()));
            }
            if (this.getName() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getName().compareTo(o.getName()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// Seller.java merge-point
}